#!/sw/bin/perl -w

use strict;
no strict "vars";

use Date::Calc qw(:all);
use Date::Calendar;

# How many days in advance:

$Days = 90; # = roughly 3 months

Language(3);

$Appointments =
{
    "Personalgesprch [Besprechungsraum R.101 15:00]" => "28.03.",
#   "Was [Ort 00:00]" => "00.00.",
};

$Anniversaries =
{
    "Jrg 1935"               =>  "23.02.",
    "Ina 1938"                =>  "19.06.",
    "Tante Barb 1933"         =>  "02.06.",
    "Onkel Siegfried 1932"    =>  "07.07.",
    "Omi 1910"                =>  "09.06.",
    "Meiner Oma 1910"        =>  "23.07.",
    "Grita Thre 1937"        =>  "23.11.",
    "Markus Thre 1967"       =>  "16.08.", # In Via GmbH, 08179/99 78-33, 08179/1081
    "Tilman 1964"             =>  "25.04.", # 089/41 52 734
    "Ulrike 1959"             =>  "15.04.",
    "Ana Maria 1977"          =>  "30.07.",
    "Anamir 1937"             =>  "30.08.",
    "Christoph 1990"          =>  "11.04.",
    "Elizabeth 1967"          =>  "16.10.",
    "Elizabeth (falsch) 1966" =>  "04.06.",
    "Francoise 1967"          =>  "16.10.",
    "Sherolize 1980"          =>  "02.10.",
    "Johanna 1971"            =>  "28.12.",
    "Alicia 2001"             =>  "25.03.",
    "Johanna & Andr 1998"    =>  "29.12.",
    "Ma & Pa 1963"            =>  "29.07.",
    "Mariclia 1968"          =>  "11.10.",
    "Adelma 1969"             =>  "11.08.",
    "Janimeire 1967"          =>  "18.06.",
    "Euzamar 1947"            =>  "13.09.",
    "Eudes 1985"              =>  "26.09.",
    "Signa 1978"              =>  "11.01.",
    "Nalva 1954"              =>  "21.10.",
    "Larissa 1987"            =>  "24.04.",
#   "Avelar 1974"             =>  "28.05.",
#   "Avelange 1979"           =>  "08.07.",
#   "Mnica 1976"             =>  "01.07.",
#   "Daniela 1981"            =>  "20.08.",
#   "Dbora 1983"             =>  "16.03.",
    "Inz 1957"               =>  "28.09.",
    "Klaus 1958"              =>  "04.02.",
    "Sandro 1966"             =>  "07.01.",
    "Kle 1964"                =>  "21.11.",
#   "Almute Heider 1965"      =>  "03.09.",
#   "Ralf Bielack 1963"       =>  "23.03.",
#   "Verena Lenzen 1967"      =>  "14.09.",
#   "Albert Eiden 1967"       =>  "02.07.",
#   "Stefan Witt 1967"        =>  "19.05.",
#   "Uschi Witt 1969"         =>  "19.08.",
    "Brigitte Krings 1967"    =>  "11.07.",
#   "Michael Ney 1964"        =>  "16.06.",
    "Astrid Hbner 1945"      =>  "02.08.",
    "Karl-Heinz Storm 1953"   =>  "23.01.",
    "Renate Graf 1938"        =>  "10.01.",
    "Heike Tschirner"         =>  "09.03.",
    "Rdiger Lars 1970"       =>  "13.04.",
    "Evanete 1970"            =>  "15.01.",
    "Annegret Franken 1962"   =>  "28.05.",
#   "Holger Wrede 1971"       =>  "02.07.",
#   "Hans-Wilhelm Wrede 1935" =>  "14.10.",
#   "Anita Wrede 1938"        =>  "19.10.",
#   "Patrick Wrede"           =>  "20.11.",
    "Madeleine 1976"          =>  "21.09.",
#   "Ftima"                  =>  "",
    "Max 1964"                =>  "25.06.",
    "Eugnio"                 =>  "25.01.",
    "Silvana 1966"            =>  "07.05.",
    "Heiner Schaffrath 1934"  =>  "12.03.",
};

$calendar = Date::Calendar->new( $Anniversaries );

@date = Today(); $start = 0;

if (@ARGV and $ARGV[0] =~ /^\d+$/)
{
    $start = -$ARGV[0];
    @date = Add_Delta_Days(Today(),$start);
    $Days += $start;
}

for ( $delta = $start; $delta <= $Days; $delta++ )
{
    if ($calendar->is_full(@date) and
        ((@labels = $calendar->labels(@date)) > 1))
    {
        $dow = shift(@labels);
        foreach $name (sort @labels)
        {
            $age = '';
            if ($name =~ s!\s*(\d+)\s*$!!)
            {
                $age = $date[0] - $1;
            }
            printf
            (
                "%+5d Tage :  %-11s %2d-%3.3s-%d  (%2s)  %s\n",
                $delta,
                $dow,
                $date[2],
                Month_to_Text($date[1]),
                $date[0],
                $age,
                $name
            );
        }
    }
    @date = Add_Delta_Days(@date,1) if ($delta < $Days);
}

print "+--------------------------------------------------------------+\n";

$calendar = Date::Calendar->new( $Appointments );

@date = Today();

for ( $delta = 0; $delta <= $Days; $delta++ )
{
    if ($calendar->is_full(@date) and
        ((@labels = $calendar->labels(@date)) > 1))
    {
        $dow = shift(@labels);
        foreach $name (sort @labels)
        {
            $time = '';
            if ($name =~ s!\s*(\d{1,2}:\d{2})\s*\]\s*$!]!)
            {
                $time = $1;
            }
            printf
            (
                "%+5d Tage :  %-11s %2d-%3.3s-%d  %5s  %s\n",
                $delta,
                $dow,
                $date[2],
                Month_to_Text($date[1]),
                $date[0],
                $time,
                $name
            );
        }
    }
    @date = Add_Delta_Days(@date,1) if ($delta < $Days);
}

__END__

